; ADCDACINT_504.a51	XFER from ADC to DAC on interrupt
;   	4/01: uses amended port assignments, and just one 
;      data pointer: 5/04 place all ISR at vector location

; should read ADC, write to DAC, start ADC each time interrupted

; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC)

    STACKBOT EQU 80h	; Not necessary, but a good place for it

	ORG 0H
	AJMP STARTUP

	ORG 0E0h
				
STARTUP: MOV SP, #STACKBOT-1
	ACALL    INITDACPTRS         ;GO INITIALIZE ptrs for ADC & DAC

; ----NOW ENABLE INTERRUPTS----

	SETB TCON.0		; Here's my first attempt to use a bit
						;  operation: make INT0 Edge-sensitive	
	SETB IE.0		; ...and enable INT0
	SETB IE.7		; Global int enable

STUCK:	SJMP STUCK		; AWAIT INTERRUPTS 


;** INITS ***************

INITDACPTRS:	MOV DPTR, #8003h 		; Here, init ADC data pointer,
	MOVX @DPTR, A	; For first pass: send anything--just a pulse to START ADC
	RET	

;** ISR: ADC-->DAC *****
; VECTOR, FROM INTERRUPT:	
	ORG INT0VECTOR
	
MOVX A, @DPTR		; Read ADC (port 3)
	MOVX @DPTR, A	; send anything--just a pulse to START of ADC, for next pass
	DEC DPL			; now point to DAC (port 2) (this DEC operates on low-byte only)

	MOVX @DPTR, A	; ...send the sample to DAC
	INC DPL			; Revert to ADC data pointer, for next pass
	RETI

END
	
